﻿
// espfilemanagerDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "espfilemanager.h"
#include "espfilemanagerDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CespfilemanagerDlg ダイアログ



CespfilemanagerDlg::CespfilemanagerDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_ESPFILEMANAGER_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	hEditExtend = NULL;
	serial_active = false;
	pSerialThread = NULL;
	last_serialreceive = 0;
	newresponse = false;
	pfree = 0;
	prange = 0;
	psize = 0;
	s_filesize = 0;
	serialbuff = NULL;
	serialsize = 0;
	intransit = false;
}

void CespfilemanagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_COM, mComboCom);
	DDX_Control(pDX, IDC_EDIT_STATUS, mEditStatus);
	DDX_Control(pDX, IDC_LIST_FILE, mListFile);
	DDX_Control(pDX, IDC_PROGRESS_VOLUME, mProgVol);
	DDX_Control(pDX, IDC_BUTTON_DEL, mBtnDel);
	DDX_Control(pDX, IDC_BUTTON_REF, mBtnRef);
	DDX_Control(pDX, IDC_BUTTON_SERIAL, mBtnSerial);
	DDX_Control(pDX, IDC_BUTTON_REFRESH, mBtnRefresh);
	DDX_Control(pDX, IDC_BUTTON_DOWN, mBtnDown);
}

BEGIN_MESSAGE_MAP(CespfilemanagerDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_BUTTON_REF, &CespfilemanagerDlg::OnClickedButtonRef)
	ON_BN_CLICKED(IDC_BUTTON_SERIAL, &CespfilemanagerDlg::OnClickedButtonSerial)
	ON_CBN_SELCHANGE(IDC_COMBO_COM, &CespfilemanagerDlg::OnSelchangeComboCom)
	ON_LBN_DBLCLK(IDC_LIST_FILE, &CespfilemanagerDlg::OnDblclkListFile)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, &CespfilemanagerDlg::OnBnClickedButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_DEL, &CespfilemanagerDlg::OnBnClickedButtonDel)
	ON_BN_CLICKED(IDCANCEL, &CespfilemanagerDlg::OnBnClickedCancel)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_DOWN, &CespfilemanagerDlg::OnBnClickedButtonDown)
END_MESSAGE_MAP()


// CespfilemanagerDlg メッセージ ハンドラー

BOOL CespfilemanagerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	//get file path for module and ini file
	wchar_t szPath[_MAX_PATH];
	wchar_t szDrive[_MAX_DRIVE];
	wchar_t szDir[_MAX_DIR];
	wchar_t szFileName[_MAX_FNAME];
	wchar_t szExt[_MAX_EXT];
	GetModuleFileName(NULL, szPath, sizeof(szPath)/2);
	//_wsplitpath_s(szPath, szDrive, szDir, szFileName, szExt);
	_wsplitpath_s(szPath, szDrive, szDir, szFileName, szExt);
	basepath.Format(L"%s%s", szDrive, szDir);
	baseini.Format(L"%s%s.ini", basepath.GetBuffer(0), szFileName);

	updateComList();

	//get default com port
	wchar_t wcsbuf[256];
	GetPrivateProfileString(L"setting", L"com", L"", wcsbuf, 254, baseini);
	mComboCom.SelectString(-1, wcsbuf);
	if (mComboCom.GetCurSel() < 0)
		mComboCom.SetCurSel(0);

	//extend memory for CEdit
	hEditExtend = ::LocalAlloc(LHND, 327680);
	::LocalFree(mEditStatus.GetHandle());
	mEditStatus.SetHandle(hEditExtend);
	mEditStatus.SetLimitText(327680);

	pSerialThread = NULL;

	mBtnDel.EnableWindow(FALSE);
	mBtnRef.EnableWindow(FALSE);
	mBtnDown.EnableWindow(FALSE);

	//buffer for serial data, 10MB should be enough
	serialbuff = new char[10240000];
	if (serialbuff == NULL) {
		AfxMessageBox(L"Memory allocation error");
	}
	else {
		//AppendText(L"");
	}

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CespfilemanagerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CespfilemanagerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CespfilemanagerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CespfilemanagerDlg::OnDropFiles(HDROP hDropInfo)
{
	int ncnt = 0;
	UINT unSize;
	TCHAR szPath[_MAX_PATH + 1];

	while (1)
	{
		unSize = ::DragQueryFile(hDropInfo, ncnt++, szPath, _MAX_PATH);
		if (unSize <= 0)
			break;
	}
	//複数ファイルサポートは中断処理を入れるのが面倒なので一つだけ・・・
	if (!intransit)
		UploadSerialfile(szPath);

	CDialogEx::OnDropFiles(hDropInfo);
}


void CespfilemanagerDlg::OnClickedButtonRef()
{
	if (intransit) return;
	CFileDialog oFileDlg(TRUE, L"*", s_filename, NULL, L"All Files (*.*)|*.*||", NULL);
	if (oFileDlg.DoModal() == IDOK)
	{
		CString fname;
		fname = oFileDlg.GetPathName();
		UploadSerialfile(fname);
	}
}


void CespfilemanagerDlg::OnClickedButtonSerial()
{
	if (intransit) return;
	//open or close serial connection
	if (pSerialThread != NULL) {
		SendSerial(L"mode 0");
		CloseSerial();
		if (pSerialThread == NULL) {
			mBtnSerial.SetWindowTextW(L"接続");
			mBtnDel.EnableWindow(FALSE);
			mBtnRef.EnableWindow(FALSE);
			mBtnDown.EnableWindow(FALSE);
			mBtnRefresh.EnableWindow();
			mComboCom.EnableWindow();
		}
		AppendText(L"Port closed");
		mListFile.ResetContent();
		mProgVol.SetPos(0);
		return;
	}

	CString csbuf;
	UpdateData();
	if (mComboCom.GetCurSel() >= 0) {
		mComboCom.GetWindowTextW(csbuf);
		WritePrivateProfileString(L"setting", L"com", csbuf, baseini);
		serial_active = true;
		if (StartSerial(csbuf)) {
			SendSerial(L"mode 5");
			AppendText(L"Change mode...");
			mBtnSerial.SetWindowTextW(L"切断");
		}
		else
			AfxMessageBox(L"COMポートを開く事ができませんでした");
	}
	else {
		AfxMessageBox(L"COMポートを選択してください");
	}
}


void CespfilemanagerDlg::OnSelchangeComboCom()
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。
}


void CespfilemanagerDlg::OnBnClickedButtonDown()
{
	OnDblclkListFile();
}


void CespfilemanagerDlg::OnDblclkListFile()
{
	if (intransit) return;
	//download file
	int fileid;
	fileid = mListFile.GetCurSel();
	if (fileid >= 0) {
		CString csbuf, cssub;
		csbuf.Format(L"down %d", fileid + 1);
		SendSerial(csbuf);
	}
}


void CespfilemanagerDlg::OnBnClickedButtonRefresh()
{
	//update com port list
	CString csbuf;
	UpdateData();
	if (mComboCom.GetCurSel() >= 0)
		mComboCom.GetWindowTextW(csbuf);
	updateComList();
	mComboCom.SelectString(-1, csbuf);
}

void CespfilemanagerDlg::updateComList() {
	CString csbuf;
	HANDLE sport;
	mComboCom.ResetContent();
	for (int i = 1; i < 40; i++) {
		csbuf.Format(L"\\\\.\\COM%d", i);
		sport = CreateFile(csbuf, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
		if (sport != INVALID_HANDLE_VALUE) {
			csbuf.Format(L"COM%d", i);
			mComboCom.AddString(csbuf);
			CloseHandle(sport);
		}
	}
}

void CespfilemanagerDlg::AppendText(CString txt, BOOL ret) {
	CString msg;
	msg = txt;
	if (ret)
		msg += "\r\n";

	int nLen = mEditStatus.GetWindowTextLength();
	mEditStatus.SetSel(nLen, nLen);
	mEditStatus.ReplaceSel(msg);
}

void CespfilemanagerDlg::OnBnClickedButtonDel()
{
	if (intransit) return;
	int fileid;
	fileid = mListFile.GetCurSel();
	if (fileid >= 0) {
		CString csbuf, cssub;
		mListFile.GetText(fileid, csbuf);
		cssub.Format(L"%sを削除してよろしいですか？", csbuf);
		if (AfxMessageBox(cssub, MB_OKCANCEL) == IDOK) {
			csbuf.Format(L"del %d", fileid+1);
			SendSerial(csbuf);
		}
	}
}


void CespfilemanagerDlg::OnBnClickedCancel()
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。
	CDialogEx::OnCancel();
}


void CespfilemanagerDlg::OnCancel()
{
	// TODO: ここに特定なコードを追加するか、もしくは基底クラスを呼び出してください。
	CDialogEx::OnCancel();
}


void CespfilemanagerDlg::OnClose()
{
	cleanup();

	CDialogEx::OnClose();
}


void CespfilemanagerDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	cleanup();
}

void CespfilemanagerDlg::cleanup()
{
	static bool called = false;
	if (called) return;
	called = true;

	if (serialbuff != NULL) {
		delete(serialbuff);
	}
	if (pSerialThread != NULL) {
		SendSerial(L"mode 0");
		CloseSerial();
	}
}

BOOL CespfilemanagerDlg::StartSerial(CString port) {
	CString csport;
	if (pSerialThread != NULL)
		return TRUE;

	mListFile.ResetContent();
	newresponse = false;
	ClearSerialbuff();
	if (port.IsEmpty()) return FALSE;
	if (!serial.init(port))
		return FALSE;

	pSerialThread = AfxBeginThread(SerialReceiveThread, (LPVOID)this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL);
	if (pSerialThread)
	{
		pSerialThread->m_pMainWnd = this;
		pSerialThread->m_bAutoDelete = FALSE;
		pSerialThread->ResumeThread();
		return TRUE;
	}
	return FALSE;
}

void CespfilemanagerDlg::CloseSerial() {
	serial_active = false;
	if (pSerialThread) {
		serial.clearBuffer();
		serial.stopreceive();
		if (::WaitForSingleObject(pSerialThread->m_hThread, 0) != WAIT_OBJECT_0) {
			if (::WaitForSingleObject(pSerialThread->m_hThread, 3000) == WAIT_TIMEOUT)
				::TerminateThread(pSerialThread->m_hThread, 0xffffffff);
		}
		delete pSerialThread;
		pSerialThread = NULL;
	}
	serial.close();
}

void CespfilemanagerDlg::SendSerial(CString msg) {
	CStringA cabuf;
	cabuf = msg;
	char buffer[256];
	sprintf_s(buffer, "%s\n", cabuf.GetBuffer(0));

	if (!serial.sendData((BYTE*)&buffer[0], strlen(buffer))) {
		AppendText(L"Serial send error");
	}
}

UINT CespfilemanagerDlg::SerialReceiveThread(LPVOID pParam) {
	CespfilemanagerDlg* pwnd = (CespfilemanagerDlg*)pParam;
	int ret;
	while (pwnd->serial_active) {
		ret = pwnd->serial.ReceiveData(INFINITE);
		if (ret == 1)
			pwnd->AppendSerial();
		else if (ret == 0)
			break;
	}
	return 0;
}

void CespfilemanagerDlg::ClearSerialbuff() {
	serialsize = 0;
	memset(serialbuff, 0, 10240000);
}

void CespfilemanagerDlg::SaveSerialfile() {
	CFileDialog oFileDlg(FALSE, L"*", s_filename, OFN_OVERWRITEPROMPT, L"All Files (*.*)|*.*||", NULL);
	if (oFileDlg.DoModal() == IDOK)
	{
		CString fname;
		fname = oFileDlg.GetPathName();
		CFile cfile;
		if (cfile.Open(fname, CFile::modeWrite | CFile::modeCreate)) {
			cfile.Write(serialbuff, s_filesize);
			cfile.Close();
			AppendText(L"Saved file");
		}
		else
			AfxMessageBox(L"ファイルの保存に失敗しました");
	}
	mProgVol.SetRange(0, prange);
	mProgVol.SetPos(psize);
}

void CespfilemanagerDlg::UploadSerialfile(CString fname) {
	if (intransit) return;

	intransit = true;
	if (!pSerialThread) {
		AppendText(L"Serial not connected");
		intransit = false;
		return;
	}

	if (!PathFileExists(fname)) {
		AfxMessageBox(L"ファイルが見つからないかアクセスできません");
		intransit = false;
		return;
	}

	CString csbuf;
	CFileStatus fileStatus;
	if (CFile::GetStatus(fname, fileStatus)) {
		CFile cfile;
		DWORD sentbyte = 0, fsize, dwread;
		fsize = fileStatus.m_size;
		if (fsize/1024 >= pfree) {
			csbuf.Format(L"空き容量が足りません 空き：%ldkb サイズ：%ldkb", pfree, fsize/1024);
			AfxMessageBox(csbuf);
			intransit = false;
			return;
		}

		if (cfile.Open(fname,CFile::modeRead|CFile::typeBinary)) {
			wchar_t szDrive[_MAX_DRIVE];
			wchar_t szDir[_MAX_DIR];
			wchar_t szFileName[_MAX_FNAME];
			wchar_t szExt[_MAX_EXT];
			_wsplitpath_s(fname, szDrive, szDir, szFileName, szExt);

			csbuf.Format(L"-----\r\nUploading %s%s", szFileName, szExt);
			AppendText(csbuf);
			csbuf.Format(L"up\n%s%s\n%ld", szFileName, szExt, fsize);
			mProgVol.SetRange32(0, fileStatus.m_size);
			mProgVol.SetPos(0);
			SendSerial(csbuf);
			BYTE buff[512];

			Sleep(1000); //need bit delay for esp32 to get ready

			while (sentbyte < fsize) {
				dwread = cfile.Read(buff, 512);
				if (serial_active) {
					if (!serial.sendData(buff, dwread)) {
						AppendText(L"Serial send error");
						cfile.Close();
						CloseSerial();
						if (pSerialThread == NULL) {
							mBtnSerial.SetWindowTextW(L"接続");
							mBtnDel.EnableWindow(FALSE);
							mBtnRef.EnableWindow(FALSE);
							mBtnDown.EnableWindow(FALSE);
							mBtnRefresh.EnableWindow();
							mComboCom.EnableWindow();
						}
						mListFile.ResetContent();
						mProgVol.SetPos(0);
						intransit = false;
						return;
					}
				}
				else {
					intransit = false;
					return;
				}
				sentbyte += dwread;
				mProgVol.SetPos(sentbyte);
				FlushMessage();
			}

			cfile.Close();
			csbuf.Format(L"sent %d bytes", sentbyte);
			AppendText(csbuf);
			AppendText(L"File sent");
			//SendSerial(L"list");
		}
		else {
			AfxMessageBox(L"ファイルが見つからないかアクセスできません");
		}
	}
	intransit = false;
}

void CespfilemanagerDlg::FlushMessage()
{
	MSG wmsg;
	if (::PeekMessage(&wmsg, NULL, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&wmsg);
		::DispatchMessage(&wmsg);
	}
}

void CespfilemanagerDlg::AppendSerial() {
	DWORD current_time;
	CString cabuf, csbuf;

	//trash old data
	current_time = GetTickCount();
	if (current_time - last_serialreceive > 5000) {
		responsemode = RES_NONE;
		ClearSerialbuff();
	}
	last_serialreceive = GetTickCount();

	//receiving file data
	if (responsemode == RES_FILE_DATA) {
		for (int i = 0; i < serial.recvSize; i++) {
			serialbuff[serialsize++] = serial.recvBuffer[i];
		}
		mProgVol.SetPos(serialsize);
		if (serialsize >= s_filesize) {
			AppendText(L"File receive complete");
			SaveSerialfile();
			ClearSerialbuff();
			responsemode = RES_NONE;
		}
		FlushMessage();
		return;
	}

	//check serial response
	//response format:
	//-----\n
	//[type]\n
	//[data]\n
	//\n
	for (int i = 0; i < serial.recvSize; i++) {
		if (responsemode != RES_FILE_DATA && serial.recvBuffer[i] == '\n') {
			cabuf = serialbuff;
			csbuf = cabuf;
			if (csbuf.GetLength() > 1 && responsemode != RES_FILE && responsemode != RES_FILE_SIZE && responsemode != RES_FILE_DATA)
				AppendText(csbuf);
			if (csbuf == L"-----") {
				newresponse = true;
				ClearSerialbuff();
				responsemode = RES_NONE;
			}
			else {
				if (newresponse) {
					if (csbuf == L"mode")
						responsemode = RES_MODE;
					else if (csbuf == L"list") {
						responsemode = RES_LIST;
						mListFile.ResetContent();
					}
					else if (csbuf == L"error")
						responsemode = RES_ERR;
					else if (csbuf == L"file")
						responsemode = RES_FILE;
					else if (csbuf == L"message")
						responsemode = RES_MSG;
				}
				else {
					if (responsemode == RES_MODE){
						if (_wtoi(csbuf.Left(csbuf.Find(L" ")).GetBuffer(0)) == 5) {
							AppendText(L"Switch mode ok");
							SendSerial(L"list");
							mBtnDel.EnableWindow();
							mBtnRef.EnableWindow();
							mBtnDown.EnableWindow();
							mBtnRefresh.EnableWindow(FALSE);
							mComboCom.EnableWindow(FALSE);
						}
						responsemode = RES_NONE;
					}
					else if (responsemode == RES_LIST) {
						if (csbuf.Find(L":") != -1) {
							CString cssub, csfname;
							int fsize;
							cssub = csbuf.Right(csbuf.GetLength() - csbuf.ReverseFind(L' '));
							fsize = _wtoi(cssub);
							cssub = csbuf.Right(csbuf.GetLength() - csbuf.Find(L'/') - 1);
							cssub = cssub.Left(cssub.ReverseFind(':') - 6);
							csfname.Format(L"%s [%d]", cssub, fsize);
							mListFile.AddString(csfname);
						}
						else if (csbuf.Find(L"kb") != -1) {
							int sttl, sused;
							CString cssub;
							cssub = csbuf.Left(csbuf.Find(L"kb total"));
							cssub = cssub.Right(cssub.GetLength() - cssub.ReverseFind(L' '));
							sttl = _wtoi(cssub);
							cssub = csbuf.Left(csbuf.Find(L"kb used"));
							cssub = cssub.Right(cssub.GetLength() - cssub.ReverseFind(L' '));
							sused = _wtoi(cssub);
							mProgVol.SetRange(0, sttl);
							mProgVol.SetPos(sused);
							prange = sttl;
							psize = sused;
							pfree = sttl - sused;
							//csbuf.Format(L"%d / %d", sttl, sused);
							//AppendText(csbuf);
							responsemode = RES_NONE;
						}
					}
					else if (responsemode == RES_MSG) {
						responsemode = RES_NONE;
					}
					else if (responsemode == RES_ERR) {
						//AppendText(csbuf);
						responsemode = RES_NONE;
					}
					else if (responsemode == RES_FILE) {
						s_filename = csbuf;
						AppendText(L"Name: ", false);
						AppendText(s_filename);
						responsemode = RES_FILE_SIZE;
					}
					else if (responsemode == RES_FILE_SIZE){
						s_filesize = _wtol(csbuf);
						csbuf.Format(L"Size: %d", s_filesize);
						AppendText(csbuf);
						if (s_filesize > 1 && s_filesize <= 10240000) {
							mProgVol.SetRange(0, s_filesize);
							mProgVol.SetPos(0);
							responsemode = RES_FILE_DATA;
							i++; //trash \n
						}
						else
							responsemode = RES_NONE;
					}
				}
				ClearSerialbuff();
				newresponse = false;
			}
		}

		if (responsemode != RES_FILE_DATA) {
			if (serial.recvBuffer[i] != '\n' && serial.recvBuffer[i] != '\r')
				serialbuff[serialsize++] = serial.recvBuffer[i];
			if (serialsize >= 10240000) { //mem full
				ClearSerialbuff();
			}
		}
		else {
			serialbuff[serialsize++] = serial.recvBuffer[i];
			if (serialsize >= s_filesize) {
				AppendText(L"File receive complete");
				mProgVol.SetPos(serialsize);
				SaveSerialfile();
				ClearSerialbuff();
				responsemode = RES_NONE;
			}
		}
	}
	if (responsemode == RES_FILE_DATA) {
		mProgVol.SetPos(serialsize);
		FlushMessage();
	}
}
