﻿
// espfilemanagerDlg.h : ヘッダー ファイル
//

#pragma once

#include "SerialControl.h"

#define RES_NONE	0
#define RES_MODE	1
#define RES_LIST	2
#define RES_ERR		3
#define RES_FILE	4
#define RES_FILE_SIZE	5
#define RES_FILE_DATA	6
#define RES_MSG		7

// CespfilemanagerDlg ダイアログ
class CespfilemanagerDlg : public CDialogEx
{
// コンストラクション
public:
	CespfilemanagerDlg(CWnd* pParent = nullptr);	// 標準コンストラクター

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ESPFILEMANAGER_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV サポート


// 実装
protected:
	HICON m_hIcon;

	CString basepath;	//exeがあるファイルパス
	CString baseini;	//iniファイル
	HLOCAL hEditExtend;

	// 生成された、メッセージ割り当て関数
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	void updateComList();
	void cleanup();
	void FlushMessage();

	SerialControl serial;
	static UINT SerialReceiveThread(LPVOID pParam);
	BOOL StartSerial(CString port);
	void CloseSerial();
	void AppendSerial();
	void ClearSerialbuff();
	void SendSerial(CString msg);
	void SaveSerialfile();
	void UploadSerialfile(CString fname);
	CWinThread* pSerialThread;
	bool serial_active;
	char *serialbuff;
	long serialsize;
	DWORD last_serialreceive;
	bool newresponse;
	int responsemode;
	CString s_filename;
	long s_filesize;
	int prange, psize, pfree;
	bool intransit;

public:
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnClickedButtonRef();
	afx_msg void OnClickedButtonSerial();
	afx_msg void OnSelchangeComboCom();
	CComboBox mComboCom;
	CEdit mEditStatus;
	CListBox mListFile;
	afx_msg void OnDblclkListFile();
	afx_msg void OnBnClickedButtonRefresh();
	CProgressCtrl mProgVol;

	void AppendText(CString txt, BOOL ret = true);
	afx_msg void OnBnClickedButtonDel();
	CButton mBtnDel;
	CButton mBtnRef;
	afx_msg void OnBnClickedCancel();
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	CButton mBtnSerial;
	CButton mBtnRefresh;
	afx_msg void OnBnClickedButtonDown();
	CButton mBtnDown;
};
